//===========================================================================
//
// 3d-tlm.h
//
// By Poman So
//
//===========================================================================


#ifndef _3d_tlm_h_
#define _3d_tlm_h_

#include "Mesh.h"

typedef float Float4[4];

extern
int   Nx_,Ny_,Nz_; // number of nodes in x, y and z direction

extern
float Cf_,Er_,Ur_, // dimension conversion factor and material constants
      Dt_;	   // delta t in seconds
extern
int   NumIts_,	   // number of iterations performed
      StopAt_,	   // stop iteration at
      Step_;	   // number of iterations per screen update
extern
float Xmin_,	   // Min and Max values in the element stack
      Ymin_,
      Zmin_,
      Xmax_,
      Ymax_,
      Zmax_;
extern
Mesh  *MeshPtr_;   // MeshPointer

#endif


//===========================================================================
//
// End of 3d-tlm.h
//
//===========================================================================
