//===========================================================================
//
// Analyzer.h
//
// By Poman So
//
//===========================================================================

#ifndef _Analyzer_h_
#define _Analyzer_h_

#include "GUI.h"
#include "Scope.h"
#include <complex>
typedef std::complex<double> Complex;

//---------------------------------------------------------------------------
//
//	Analyzer Class
//
//---------------------------------------------------------------------------
class Analyzer: public DTaskWindow{
	Label	 ref_label;
	RadioBox ref_box;
	Label	 out_label;
	RadioBox out_box,mod_box;
	GraphBox graphbox;
	Boolean	 connected,s21;
	int	 ref_statebits,out_statebits,mod_statebits;
	int	 nf;
	float	 *rFr,*rFi,*oFr,*oFi;
	char	 title[3][LB_SIZE],xlabel[3][LB_SIZE],ylabel[3][LB_SIZE];
	float	 ymin[3],ymax[3];
	int	 yticks[3];
	float	 xmin,xmax;
	int	 xticks;
	Boolean	 RefOkay();
	Complex	 S11(int i);
	Complex	 S21(int i);
	float	 GraphValue(int i);
	void	 GetGraph();
public:
	void	 SetGraph();
	void	 DrawGraph();
	Analyzer(Window &w, char *label, Boolean s21, Analyzer *A=0);
	Status	 WindowCB(CBTag tag);
	Status	 ChildCB(Window *w, CBTag tag);
	fstream	 &IO(fstream &fs);
	Analyzer *Previous(){return (Analyzer*)previous;}
	Analyzer *Next(){return (Analyzer*)next;}
	Boolean  Connected(){return connected;}
	void	 Connect(Boolean c=True){connected=c;}
	void	 Init();
	void	 Update(Boolean must_refresh=False);
	int	 RefNum(){return (ref_statebits==1)?0:
			         (ref_statebits==2)?1:2;}
	int	 OutNum(){return (out_statebits==1)?0:
			         (out_statebits==2)?1:2;}
	void	 Ref(float *Fr, float *Fi){rFr=Fr; rFi=Fi;}
	void	 Out(float *Fr, float *Fi){oFr=Fr; oFi=Fi;}
	void	 FreqInfo(int n, float f1, float f2){
		   nf=n;  xmin=f1;  xmax=f2;
		 }
};//--- Analyzer ---//



#endif

//===========================================================================
//
// End of Analyzer.h
//
//===========================================================================
