//===========================================================================
//
// Scope.h
//
// By Poman So
//
//===========================================================================

#ifndef _Scope_h_
#define _Scope_h_

#include "GUI.h"


//---------------------------------------------------------------------------
//
//	Scope Class
//
//---------------------------------------------------------------------------
#define MAX_NUMT 65535
#define MAX_NUMF 2047

class Scope: public DTaskWindow{
	RadioBox   fieldbox,domainbox;
	PushButton dftbutton;
	GraphBox   graphbox;
	Boolean	   connected;
	int	   fb_statebits,db_statebits;
	char	   title[3][LB_SIZE],xlabel[3][LB_SIZE],ylabel[3][LB_SIZE];
	float	   ymin[3],ymax[3];
	int	   yticks[3];
	float	   xmin[3],xmax[3];
	int	   xticks[3];
	int        nf;
	float      *t,*Fr,*Fi;
	int        xs,ys,zs;	// sampling point
	void	   DrawTimeGraph(Boolean allterms=True);
	void	   DrawFAmpGraph();
	void	   DrawFAngGraph();
	void	   DrawGraph(Boolean allterms=True);
	void	   GetGraph();
	void	   SetGraph();
public:
	Status	 SelectCB(char *title=0);
	void	 DFT();
	Scope(Window &w, char *label, Scope *S=0);
	~Scope();
	Status	 WindowCB(CBTag tag);
	Status	 ChildCB(Window *w, CBTag tag);
	fstream	 &IO(fstream &fs);
	void	 FreqRes(fstream &fs);
	void	 TimeRes(fstream &fs);
	Scope    *Previous(){return (Scope*)previous;}
	Scope    *Next(){return (Scope*)next;}
	void	 DFT(int n, Boolean forward=True);
	void	 Init();
	void	 SetSamplingPoint(int *xyz){
		   xs=xyz[0]; ys=xyz[1]; zs=xyz[2];
		 }
	Boolean  Connected(){return connected;}
	void	 Connect(Boolean c=True){connected=c;}
	void	 Update(Boolean must_refresh=False,Boolean forward=True);
	void	 CopySimData(Scope &a);
	float    *Fr_Ptr(){return Fr;}
	float	 *Fi_Ptr(){return Fi;}
	int	 Nf(){return nf;}
	float	 F1(){return xmin[1];}
	float	 F2(){return xmax[1];}
};//--- Scope ---//



#endif

//===========================================================================
//
// End of Scope.h
//
//===========================================================================
